<?php if(!defined('PmWiki')) exit();

 /**
 *  Copyright 2011 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/// CSSCOMPRESS - Compresses skin and recipe css files.

/// VARIABLES

$RecipeInfo['csscompress']['version'] = '20110327';
$HandleActions['csscompress'] = 'HandleCssCompress';
$HandleAuth['csscompress'] = 'admin';

// if you know how to optmize this 
// please write on the talk page
SDV($CssCompressRgbPat , "/rgb\(\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?\)/e");
SDV($CssCompressHexPat , "/#([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})/e");
SDV($CssCompressCommentPat , '!/\*[^*]*\*+([^/][^*]*\*+)*/!');
SDV($CssCompressTabReturnNewline, array("\r\n", "\r", "\n", "\t"));
SDV($CssCompressSpacePat , '/\s{1,15}/');
SDV($CssCompressMoreSpace , array(
  '! important' => '!important',
  ' {' => '{' , '{ ' => '{',
  '} ' => '}' , ' }' => '}',
  '( ' => '(' , ' (' => '(',
  ') ' => ')' , ' )' => ')',
  ' ,' => ',' , ', ' => ',',
  ' :' => ':' , ': ' => ':',
  ' ;' => ';' , '; ' => ';',
  ';}' => '}'
));
SDV($CssCompressColor,array(
  'black' =>'#000',
  'fuchsia' => '#f0f',
  // there is a 'white-space' confusion
  // we will miss the chance to optimize 
  // the background selector
  // when it gets more complex
  ':white' => ':#fff',
  'yellow' => '#FF0',

  '#800000' => 'maroon',
  '#ffa500' => 'orange',
  '#808000' => 'olive',
  '#800080' => 'purple',
  '#008000' => 'green',
  '#000080' => 'navy',
  '#008080' => 'teal',
  '#c0c0c0' => 'silver',
  '#808080' => 'gray',
  '#f00' => 'red'
));
SDV($CssCompressFontWeight, array(
  'font-weight:bold' => 'font-weight:700',
  'font-weight:normal' => 'font-weight:400'
));
SDV($CssCompressOverWrite , true);
// complete or relative path to files
// don't forget to check file permissions
// I decided not to touch it from here
// it also accepts anything that
// can be replaced by FmtPageName
SDV($CssCompressFiles , array(
  './pub/skins/pmwiki/pmwiki.css' => './pub/skins/pmwiki/pmwiki.cmp.css',
));

// message to show
// as part of the page
// when csscompress is called
SDV($CssCompressMessage, '
(:title Action -> Css Compress :)
(:div style="text-align:center":)
You have to fill the array called $CssCompressFiles so this action can work.[[<<]]
Click the link bellow to see some action![[<<]]
[[{$ScriptUrl}?n={$FullName}&action=csscompress| CSS COMPRESS]] [[<<]]
[[<<]]
You can change this message editing the var called $CssCompressMessage[[<<]]
(:divend:)
----[[<<]]'
);

/// FUNCTIONS

function CssCompressFirst($c){
  if($c{0} == " ")
    $c = substr($c,1);
  return $c;
}

// not all cases yet
function CssCompressUnit($c){
  for($i=1;$i<=9;$i++){
    $c = preg_replace("/0{1,10}[\.,]".$i."0{0,10}(px|ex|em|pt)/",".$i$1",$c);
  }
return $c;
}

function CssCompressShortHex($r,$g,$b){
  $r1 = substr($r,0,1);$r2= substr($r,1,2); 
  if($r1 == $r2) $re = 1; else $re = 0;
  $g1 = substr($g,0,1);$g2= substr($g,1,2); 
  if($g1 == $g2) $ge = 1;else $ge = 0;
  $b1 = substr($b,0,1);$b2= substr($b,1,2); 
  if($b1 == $b2) $be = 1;else $be = 0;
  if($re == 1 && $ge == 1 && $be == 1 ){
    $out = "#".$r1.$g1.$b1 ;
  }else{
    $out = "#".$r.$g.$b;
  }
  return strtolower($out);
}

function CssCompressRgb2Hex($r,$g,$b){
  $r = dechex($r);$g = dechex($g);$b = dechex($b);
  return shorthex($r,$g,$b);
}

function CssCompress($buffer) {
  global $CssCompressRgbPat,$CssCompressHexPat,$CssCompressCommentPat,
    $CssCompressTabReturnNewline,$CssCompressSpacePat,
    $CssCompressMoreSpace,$CssCompressColor,
    $CssCompressFontWeight;

  // remove comments
  $buffer = preg_replace($CssCompressCommentPat, '', $buffer);

  // transforms rgb(126,100,88) in #773344 and to short #734 colors
  $buffer = preg_replace($CssCompressRgbPat,
                   'CssCompressRgb2Hex("$1","$2","$3")',$buffer);

  // transforms  #334455 to short #345 colors
  $buffer = preg_replace($CssCompressHexPat,
                   'CssCompressShortHex("$1","$2","$3")',$buffer);

  // more color compression
  $buffer = str_replace(array_keys($CssCompressColor),
                        array_values($CssCompressColor), $buffer);

  // remove tabs, return, newlines and combinations.
  $buffer = str_replace($CssCompressTabRetunNewline,'', $buffer);

  // replace spaces with just one space
  $buffer = preg_replace($CssCompressSpacePat,' ', $buffer);

  // more spaces
  $buffer = str_replace(array_keys($CssCompressMoreSpace),
                        array_values($CssCompressMoreSpace), $buffer);

  $buffer = str_replace(array_keys($CssCompressFontWeight),
                        array_values($CssCompressFontWeight), $buffer);

  $buffer = CssCompressUnit($buffer);

  $buffer = CssCompressFirst($buffer);

  return $buffer;
}

/// HANDLER

function HandleCssCompress($pagename,$auth='admin'){
  global $CssCompressOverWrite,$CssCompressFiles,
         $CssCompressMessage,$PageStartFmt,$PageEndFmt;

  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  if (!$page) Abort("Insufficient permissions for Css Compress");

  $msg = MarkupToHTML($pagename,$CssCompressMessage);
  foreach($CssCompressFiles as $k => $v){
    $infile = FmtPageName($k, $pagename);
    $outfile = FmtPageName($v, $pagename);
    if(!file_exists($infile)){
      $msg .= "$[Css file does not exist] -> ".$infile."<br/>\n";
    }else{
      $writeperm = false;
      if(file_exists($outfile) &&
            $CssCompressOverWrite) $writeperm = true;
      if($writeperm == false)
        $msg .= "$[Css out file can't be created] -> ".$outfile."<br/>\n";
      if(!($csscontents = file_get_contents($infile))) 
        $msg .= "$[Couldn't open css file for compression] -> ".$infile."<br/>\n";
      if(!($csscompressed = CssCompress($csscontents))) 
        $msg .= "$[Couldn't compress the opened css file] -> ".$infile."<br/>\n";
      if($csscontents != '' && $writeperm == true){
        if(!file_put_contents($outfile,$csscompressed)) 
          $msg .= "$[Couldn't open outfile] -> ".$outfile.".\n";
        else $msg .= $infile." - $[File compressed and saved in] -> ".$outfile."<br/>\n";
      }
    }
  }

  $PageCssCompressFmt = "<div>".FmtPageName($msg, $pagename)."</div>";
  SDV($HandleCssCompressFmt, array(&$PageStartFmt, &$PageCssCompressFmt, &$PageEndFmt));
  PrintFmt($pagename, $HandleCssCompressFmt);
}
